#include <CL/sycl.hpp>
#include <iostream>
#include <iomanip>
#include <ctime>
#include <sys/time.h>
//#include <cstdlib>
//#include "sycl_exceptions.hpp"
using namespace std;
int main() {
const int N = 1024*1000;
auto R = sycl::range<1>(N);
std::vector<float> v1(N);
std::vector<float> v2(N);
for(int i=0;i<N;i++) {
    v1[i] = i;
    v2[i] = i;
}
//struct timeval start, end, start1, end1;
struct timeval start, end;
//sycl::queue cpuQ(sycl::cpu_selector{},exception_handler);
sycl::queue cpuQ(sycl::cpu_selector{});
//sycl::queue gpuQ(sycl::gpu_selector{},exception_handler);
sycl::queue gpuQ(sycl::gpu_selector{});
{
//Splitting input data into 2 halves for CPU and iGPU
sycl::buffer<float,1> bufgpuv1(v1.data(), R);
sycl::buffer<float,1> bufcpuv1(v2.data(), R);
//sycl::buffer<float,1> bufcpuv1((v1.data()+(N/2)), R);
//sycl::buffer<float,1> bufcpuv2((v2.data()+(N/2)), R);
std::cout<<"Running on: "<<gpuQ.get_device().get_info<sycl::info::device::name>()<<" and "
<<cpuQ.get_device().get_info<sycl::info::device::name>()<<"\n";
gettimeofday(&start, NULL);
ios_base::sync_with_stdio(false);
gpuQ.submit([&](sycl::handler &h){
    auto agpuv1 = bufgpuv1.get_access<sycl::access::mode::read_write>(h);
    //auto agpuv2 = bufgpuv2.get_access<sycl::access::mode::read_write>(h);
    h.parallel_for (R, [=](sycl::id<1> i){
//        agpuv1[i]+=agpuv2[i];
      for(int ii=1;ii<10000;ii++) {
        float tanval = (sycl::sin(agpuv1[i])*ii)/(sycl::cos(agpuv1[i])*ii);
        float secval = 1.0/sycl::cos(agpuv1[i]);
         agpuv1[i] =  (secval*secval) - (tanval*tanval);
         }
    });
});
cpuQ.submit([&](sycl::handler &h){
    auto acpuv1 = bufcpuv1.get_access<sycl::access::mode::read_write>(h);
    //auto acpuv2 = bufcpuv2.get_access<sycl::access::mode::read_write>(h);
    h.parallel_for(R, [=](sycl::id<1> i){
        //acpuv1[i]+=acpuv2[i];
      for(int ii=1;ii<10000;ii++) {
        float tanval = (sycl::sin(acpuv1[i])*ii)/(sycl::cos(acpuv1[i])*ii);
        float secval = 1.0/sycl::cos(acpuv1[i]);
        acpuv1[i] =  (secval*secval) - (tanval*tanval);
        }
    });
});
}
gettimeofday(&end, NULL);
double time_taken;
time_taken = (end.tv_sec - start.tv_sec) * 1e6;
time_taken = (time_taken + (end.tv_usec - start.tv_usec)) * 1e-6;
cout << "Time taken by kernel is : " << fixed << time_taken << setprecision(6) << " sec " << "\n";
std::cout<<"Sample values on GPU and CPU\n";
for(int i =0; i < 10; i++)
    std::cout<<v1[i]<<" "<<v2[i]<<"\n";
//std::vector<int> validate_vector(N,N);
//validate_vector==v1?std::cout<<"Vector addition: Success\n":std::cout<<"Vector addition: Failure\n";
return 0;
}